/*
 * Copyright (c) 1997, 1998
 *      Jens Arvid Nilsson, jnilsson@ludd.luth.se. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*$Id: readconfig.h,v 1.4 1998/05/24 14:14:15 jens Exp $*/
#ifndef READCONFIG_H
#define READCONFIG_H

#include <stdio.h>

#if 0
/* ett expempel p hur det kan se ut */
#define LOCALDIR        0
#define REMOTEDIR       1
#define USERNAME        2
#define PASSWORD        3
#define HOST            4
#define RETRIES         5
#define RETRYTIME       6
#define TIMEOUT         7
#define SKIPDIR         8
#define DIRLINK         9
#define LOGFILE         10
#define MAX_CONF        10
#define FIELD_SIZE      12

static char fields[][FIELD_SIZE] = {
        "localdir",
        "remotedir",
        "username",
        "password",
        "host",
        "retries",
        "retrytime",
        "timeout",
        "skipdir",
        "dirlink",
        "logfile",
""};

#endif

struct J_value {
	struct J_value *q_forw;
	struct J_value *q_back;
	char	*szValue;
};

struct J_conf {
	struct J_conf *q_forw;
	struct J_conf *q_back;
	int		nIdx;
	int		nRow;
	char	*szOrig;
	struct J_value *pValue;
};

struct J_conf *pJ_read_config(FILE * pConfigFile, char **pFields, int nSize);
void vJ_free_config(struct J_conf *pCHead);
char *szJ_next_token(void);
char *szJ_Next_token(void);
void vJ_Expect_next_token(char *str);
int nJ_next_row(void);
int nJ_conf_row(void);
int nJ_conf_idx(void);
char *szJ_token(void);
int bJ_eo_conf(void);
char *szJ_conf_orig(void);


#endif
